import { LRParser } from '@lezer/lr';
import { styleTags, tags } from '@lezer/highlight';
import { indentNodeProp, continuedIndent, delimitedIndent, flatIndent, foldNodeProp, foldInside, LRLanguage, LanguageSupport } from '@codemirror/language';

const highlighting = styleTags({
  'Def/Ident': tags.definition(tags.variableName),
  '<-': tags.controlKeyword,
  Ident: tags.variableName,
  Class: tags.typeName,
  Literal: tags.string,
  Comment: tags.lineComment,
  '( )': tags.paren,
  '|': tags.separator,
  '[ ]': tags.squareBracket,
  '{ }': tags.brace
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser$1 = LRParser.deserialize({
  version: 14,
  states: "$zQYQPOOO_QPO'#C_OOQO'#Ct'#CtQYQPOOOdQQO,58yOOQO-E6r-E6rO!_QQO'#CjOOQO'#Cz'#CzO#nQQO'#CdO#uQQO'#CdO$yQQO'#CdOOQO'#Cu'#CuO%QQQO'#CcO%hQPO'#CbOOQO1G.e1G.eO%sQPO,59UO&sQQO,59OO'QQQO,59OOOQO,59O,59OOOQO-E6s-E6sOdQQO'#CvO'_QPO,58|OOQO1G.p1G.pOOQO1G.j1G.jOOQO,59b,59bOOQO-E6t-E6tO'jQQO'#CcO!_QQO'#CvO'}QPO,58|O(VQPO'#Cb",
  stateData: "(a~OmOSPOS~OSPO~OTSO~OSVOXWOYVOZYO]UO_VO`VOaVObVOcVOSVPgVPkVP~OSVOXWOYVOZYO]UO_VO`VOaVObVOcVO[VPgVP~OSVO]UO_VO`VOaVObVOcVO~OY`O~P#VOdbOebOfbOSWXXWXYWXZWX]WX_WX`WXaWXbWXcWXgWXkWX[WX~OYVO~P#VOXWOYVOZYOSVXgVXkVX~P#VOgdOSUXkUX~O[fO~OSWaXWaYWaZWa]Wa_Wa`WaaWabWacWagWakWa[Wa~OdnXenXfnX~P%xOdgOegOfgO~P%xOgdOSUakUa~OXWOYVOZYO[VXgVX~P#VOgkO[Ua~OgkO[UX~Om~",
  goto: "#boPPPpPPtz!UPPPPP!^PPPPPPPPP!h!n!zPPP#UTQORQ^SR_UQ]SShdkRmU]ZSU[djkaVSUWY[djkQRORTRS[SdSc[jTjUkQe]SielRlm[XSU[djkTaWY",
  nodeNames: "⚠ Comment G Def Ident <- Expr Seq Prefix & Action ! ) ( Group Literal Class . < > ? * + /",
  maxTerm: 30,
  nodeProps: [
    ["isolate", 1,""],
    ["openedBy", 12,"("],
    ["closedBy", 13,")"]
  ],
  propSources: [highlighting],
  skippedNodes: [0,1],
  repeatNodeCount: 3,
  tokenData: "2V~RgXY!jYZ!j]^!jpq!jqr!{rs#Qst&uvw'awx'fxy+Uyz+Zz{+`{|+e!O!P+j!P!Q+o!^!_+t!`!a,R!a!b,W!c!},]!}#O,n#R#S,]#T#o,]#o#p1h~!oSm~XY!jYZ!j]^!jpq!j~#QOZ~~#TYOr#Qrs#ssw#Qwx#Qx#O#Q#O#P#x#P#Q#Q#Q;'S#Q;'S;=`&o<%lO#Q~#xO_~~#{`rs#Qwx#Q}!O#Q!Q!U$}!U!Y%v!}#O#Q#O#P#Q#P#Q#Q#T#U#Q#U#V#Q#X#Y#Q#Y#Z#Q#b#c#Q#f#g#Q#h#i#Q#j#k#Q~%Q[Or#Qrs#ssw#Qwx#Qx!Q#Q!Q!Y%v!Y#O#Q#O#P#x#P#Q#Q#Q;'S#Q;'S;=`&o<%lO#Q~%y[Or#Qrs#ssw#Qwx#Qx!Q#Q!Q!Y#Q!Y#O#Q#O#P#x#P#Q#Q#Q;'S#Q;'S;=`&o<%lO#Q~&rP;=`<%l#Q~&zTP~OY&uZ]&u^;'S&u;'S;=`'Z<%lO&u~'^P;=`<%l&u~'fOX~~'iYOr'frs'fsw'fwx#sx#O'f#O#P(X#P#Q'f#Q;'S'f;'S;=`+O<%lO'f~([`rs'fwx'f}!O'f!Q!U)^!U!Y*V!}#O'f#O#P'f#P#Q'f#T#U'f#U#V'f#X#Y'f#Y#Z'f#b#c'f#f#g'f#h#i'f#j#k'f~)a[Or'frs'fsw'fwx#sx!Q'f!Q!Y*V!Y#O'f#O#P(X#P#Q'f#Q;'S'f;'S;=`+O<%lO'f~*Y[Or'frs'fsw'fwx#sx!Q'f!Q!Y'f!Y#O'f#O#P(X#P#Q'f#Q;'S'f;'S;=`+O<%lO'f~+RP;=`<%l'f~+ZO]~~+`O[~~+eOe~~+jOf~~+oOa~~+tOg~R+yPbQ}!O+|P,ROTP~,WOc~~,]Od~~,bSS~!Q![,]!c!},]#R#S,]#T#o,]~,qYOr-ars-asw-awx-ax#O-a#O#P.Y#P#Q1]#Q;'S-a;'S;=`1b<%lO-a~-d[Or-ars-asw-awx-ax}-a}!O-a!O#O-a#O#P.Y#P#Q1]#Q;'S-a;'S;=`1b<%lO-a~.]`rs-awx-a}!O-a!Q!U/_!U!Y0^!}#O-a#O#P-a#P#Q-a#T#U-a#U#V-a#X#Y-a#Y#Z-a#b#c-a#f#g-a#h#i-a#j#k-a~/b^Or-ars-asw-awx-ax}-a}!O-a!O!Q-a!Q!Y0^!Y#O-a#O#P.Y#P#Q1]#Q;'S-a;'S;=`1b<%lO-a~0a^Or-ars-asw-awx-ax}-a}!O-a!O!Q-a!Q!Y-a!Y#O-a#O#P.Y#P#Q1]#Q;'S-a;'S;=`1b<%lO-a~1bO`~~1eP;=`<%l-a~1kTO#q1h#q#r1z#r;'S1h;'S;=`2P<%lO1h~2POY~~2SP;=`<%l1h",
  tokenizers: [0, 1],
  topRules: {"G":[0,2]},
  tokenPrec: 337
});

let props, data, parser;

function foldDef
(tree) {
  let ident, arrow;

  ident = tree.firstChild;
  arrow = ident?.nextSibling;
  return arrow ? { from: arrow.to, to: tree.to } : null
}

function foldAction
(tree) {
  if ((tree.to - tree.from) > 1)
    return { from: tree.from + 1, to: tree.to - 1 }
  return null
}

props = [ indentNodeProp.add({ Def: continuedIndent({ units: 1 }),
                               Group: delimitedIndent({ closing: ')' }),
                               Action: flatIndent }), // needs something better
          foldNodeProp.add({ "Group": foldInside,
                             Def: foldDef,
                             Action: foldAction }) ];

data = { commentTokens: { line: "#" },
         closeBrackets: { brackets: "({" } }; // skip < because it affects <-

parser = parser$1.configure({ props: props });

/// A language provider, including highlighting and indentation
/// information.
const lr = LRLanguage.define({ name: 'peg',
                               parser: parser,
                               languageData: data });

/// Language support.
function language
() {
  return new LanguageSupport(lr)
}

export { language, lr };
